#pragma once
#include "player.h"

#ifdef WIN32
#	define TIME_BEFORE_AI_MOVE	15
#else
#	define TIME_BEFORE_AI_MOVE	4
#endif

class AIPlayer;

class AIThing : public PegThing
{
public:
	AIThing(AIPlayer* player);
	
	SIGNED Message(const PegMessage &msg);

	void wakeMeUpLater();
	void boatsPlaced();

private:
	AIPlayer* m_pPlayer;
};

/////////////////////////////////////////////////////////////////////////////

#define MAX_TRIES	4
#define UNKNOWN		0
#define VERTIC		1
#define HORIZ		2

struct AIBoatData
{
	AIBoatData() { boat=NULL; direc=UNKNOWN; row=col=0; }
	Boat* boat;
	byte direc;
	int row,col;
};

class AIPlayer : public Player
{
public:
	AIPlayer(int num, GameMaster* master);
	~AIPlayer(void);

		// Called by the Game Master
	int priority() { return random(2); }
	void yourTurn();
	void placeYourBoats();
	bool initOk() { return true; }

		// Called by the AIThing
	void timeToRox();
	void readyToStart();

	void myShotResult(const ShotResult &res);
	void opponentShotResult(const ShotResult &res);

private:
	void analyzeShot(const ShotResult &res);

	AIThing* m_thing;

	int m_trackedBoat;
	AIBoatData m_knowings[NBR_BOATS];
};
