#include "casedata.h"

bool CaseData::finished = false;

CaseData::CaseData()
	: opened(false)
	, boat(NULL)
{
}

/////////////////////////////////////////////////////////////////////////////

CaseType CaseData::knownType() 
{ 
	if(opened) return realType();
	else if(finished && boat) return Intact;
	else return UnKnown;
}

/////////////////////////////////////////////////////////////////////////////

CaseType CaseData::realType() 
{ 
	if(boat)
	{
		if(boat->destroyed) return Destroyed;
		else return (opened ? Hit : Intact);
	}
	else  // a bit tricky, this way the player does not see water everywhere
			// on hes grid
		return (opened? Water : UnKnown);
}

/////////////////////////////////////////////////////////////////////////////

bool CaseData::hit(ShotResult &res) 
{ 
	bool dest = false;
	if(boat) 
	{
		boat->hasBeenHit();
		res.boat = boat;
		if(boat->destroyed) dest = true;
	}
	else res.boat = NULL;

	opened = true;
	return dest;
}

/////////////////////////////////////////////////////////////////////////////

