#ifndef DISTANTPLAYER_H
#define DISTANTPLAYER_H

#include "Player.h"

class DistantPlayer;
class DistantThing : public PegThing
{
public:
	DistantThing(DistantPlayer* p);
	~DistantThing();

	SIGNED Message(const PegMessage &msg);
	void waitMessage(char* text);
	void testConnection();

private:
	int m_cpt;
	DistantPlayer* m_player;
};

/////////////////////////////////////////////////////////////////////////////

class DistantPlayer : public Player
{
public:
	DistantPlayer(int num, GameMaster* master);
	~DistantPlayer();

	void newMessage(byte msg);
	int priority() { return m_priority; }
	void yourTurn();
	void placeYourBoats();
	void opponentIsReady();
	bool initOk() { return m_initOk; }

	const ShotResult & opponentShot(int row, int col);
	void myShotResult(const ShotResult &res);

private:
	bool sendResult(const ShotResult &res);
	bool receiveResult();
	void lostConnect();

	ShotResult m_lastRes;
	int m_priority;
	Boat m_boat;
	DistantThing m_thing;
	byte m_state;
	bool m_imReady, m_otherReady;
	bool m_initOk;
};

#endif

