#pragma once
#include "main.h"

#include "CaseData.h"

class GridData
{
public:
	GridData();
	~GridData();

	CaseType getKnownCaseType(int row, int col)	{ return m_grid[row][col].knownType();}
	CaseType getRealCaseType(int row, int col){ return m_grid[row][col].realType();}

	const ShotResult & opponentShot(int row, int col);

	void clear();
	void acceptsResult(const ShotResult &res);
	bool canPlaceNewBoat(int row, int col, bool horiz, int size);
	void placeBoat(int row, int col, bool horiz, Boat* b);
	void removeBoat(int id);

	bool allBoatsPlaced();
	int getNewIdForSize(int size);

private:
	CaseData m_grid[SIZE_GRID][SIZE_GRID];
	ShotResult m_lastRes;
	Boat* m_boats[NBR_BOATS];
	int m_nbrDestroyedBoats;
	int m_nbrPlacedBoats[4];


};
