#ifndef LOCALPLAYER_H
#define LOCALPLAYER_H

#include "player.h"
#include "PlayerWdw.h"

	// "Java-like" interface implementation for PlayerDoc
class LocalPlayer :	public Player, public PlayerDoc
{
public:
	LocalPlayer(GameMaster* master);

		// PlayerDoc stuff
	void shoot(int row, int col);
	CaseType getCaseType(int player, int row, int col);
	void getChangedCase(int &row, int &col);
	bool myTurn() { return m_myTurn; }
	int boatDamage(int player, int boatId) { return m_damages[player][boatId]; }
	void setWindow(PlayerWdw* wdw) { m_window = wdw; }
	bool placingBoats() { return m_placingBoats; }
	bool canPlaceBoat(int row, int col, bool horiz, int size);
	void placeBoat(int row, int col, bool horiz, int size);

		// Player stuff
	int priority() { return 1; }
	void yourTurn();
	void placeYourBoats();
	void myShotResult(const ShotResult &res);
	void opponentShotResult(const ShotResult &res);
	bool initOk() { return true; }

	void redrawWnd();

private:
	bool userPlacesBoats() { return true; }

	PlayerWdw* m_window;

	int m_rowChanged, m_colChanged;
	bool m_myTurn;
	bool m_placingBoats;
	int m_damages[2][NBR_BOATS];
};

#endif

