#include "main.h"
#include "OptionsWdw.h"
#include "../MainFrame/MyMainFrame.h"

OptionsWdw* OptionsWdw::m_instance = NULL;
PegRect OptionsWdw::m_rect = {8,56,151,157};
bool OptionsWdw::m_enabled = true;
bool OptionsWdw::m_loaded = false;
bool OptionsWdw::m_placeBoatsManually = false;
bool OptionsWdw::m_drawAnim = true;
bool OptionsWdw::m_usbMode = false;

#define ID_ANIME_CHK		638
#define ID_PLACE_BOAT_CHK	639
#define ID_SERIAL_RADIO		640
#define ID_USB_RADIO		641
#define ID_OK_BTN			642
#define ID_CANCEL_BTN		643

/////////////////////////////////////////////////////////////////////////////

OptionsWdw::OptionsWdw()
	: MyWindow(m_rect, FF_THIN)
{
	// options: 
	//	- animations (checkbox)
	//	- placer bateau auto (checkbox)
	//	- comm : usb/serial (radio)

	m_animCheck = new PegCheckBox(4,20,GetLang(CHK_DRAW_ANIM),ID_ANIME_CHK,AF_ENABLED);
	AddR(m_animCheck);

	m_placeBoatCheck = new PegCheckBox(4,32,GetLang(CHK_PLACE_BOATS),ID_PLACE_BOAT_CHK,AF_ENABLED);
	AddR(m_placeBoatCheck);

	m_serialRadio = new PegRadioButton(4,48,GetLang(RADIO_LINK_SERIAL),ID_SERIAL_RADIO,AF_ENABLED);
	m_usbRadio = new PegRadioButton(4,60,GetLang(RADIO_LINK_USB),ID_USB_RADIO,AF_ENABLED);
	AddR(m_serialRadio);
	AddR(m_usbRadio);

	AddR( new PegTextButton(12, 80, 52, GetLang(BTN_TXT_OK), IDB_OK, AF_ENABLED|TJ_CENTER) );
	AddR( new PegTextButton(77, 80, 52, GetLang(BTN_TXT_CANCEL), IDB_CANCEL, AF_ENABLED|TJ_CENTER) );
}

/////////////////////////////////////////////////////////////////////////////

OptionsWdw::~OptionsWdw(void)
{
	saveOptions();
}

/////////////////////////////////////////////////////////////////////////////

void OptionsWdw::loadOptions()
{
	CPReadMCSFile file("BatShip", "main", IMU_MCS_TypeMem);
	
	if(file.FileExists() && file.IsNotError())
	{
		CPMEMFileHeader header("BattleShip", "Options");
		header.Read(file);
		m_drawAnim = (bool)file.ReadByte();
		m_placeBoatsManually = (bool)file.ReadByte();
		m_usbMode = (bool)file.ReadByte();
	}
}

/////////////////////////////////////////////////////////////////////////////

void OptionsWdw::saveOptions()
{
	CPWriteMCSFile file("BatShip", "main", IMU_MCS_TypeMem);
	
	CPMEMFileHeader header("BattleShip", "Options");
	header.Write(file);
	byte* buff = (byte*)&m_drawAnim;
	file.WriteBytes(buff,3);
	
	file.Realize();
	if(file.is_open())
	{
        header.Write(file);
		file.WriteByte((byte)m_drawAnim);
		file.WriteByte((byte)m_placeBoatsManually);
		file.WriteByte((byte)m_usbMode);
	}
}

/////////////////////////////////////////////////////////////////////////////

void OptionsWdw::onDraw()
{
	PegColor col(BLACK);
	PegPoint p = {52,6};
	DrawTextR(p,GetLang(CAPT_OPTIONS),col,PegTextThing::GetBasicFont());

	DrawChildren();
}

/////////////////////////////////////////////////////////////////////////////

void OptionsWdw::showWindow()
{
	if(m_enabled == false) return;

	if(m_loaded == false) loadOptions();
	if(m_instance == NULL) m_instance = new OptionsWdw();

	m_instance->m_animCheck->SetSelected(m_drawAnim);
	m_instance->m_placeBoatCheck->SetSelected(m_placeBoatsManually);
	m_instance->m_usbRadio->SetSelected(m_usbMode);
	m_instance->m_serialRadio->SetSelected(!m_usbMode);

	MyMainFrame::mf()->addWindow(m_instance);
	
	if(m_instance->ExecuteFlush(true,false)==IDB_OK)
	{
		m_drawAnim = m_instance->m_animCheck->IsChecked();
		m_placeBoatsManually = m_instance->m_placeBoatCheck->IsChecked();
		m_usbMode = m_instance->m_usbRadio->IsSelected();
		saveOptions();
	}
}

/////////////////////////////////////////////////////////////////////////////

