#include "player.h"
#include "Boat.h"

Player::Player(int num, GameMaster* master)
	: m_num(num)
	, m_pMaster(master)
{
}

/////////////////////////////////////////////////////////////////////////////

Player::~Player(void)
{
}

/////////////////////////////////////////////////////////////////////////////

void Player::shoot(int row, int col)
{
	const ShotResult &res = m_pMaster->playerShot(m_num, row, col); 
	myShotResult(res);
}

/////////////////////////////////////////////////////////////////////////////

const ShotResult & Player::opponentShot(int row, int col)
{
	const ShotResult &res = m_grid.opponentShot(row, col);
	opponentShotResult(res);
	return res;
}

/////////////////////////////////////////////////////////////////////////////

void Player::placeBoatsAuto()
{
	int row, col;
	bool horiz;
	int i=0;

	byte tries[NBR_BOATS];
	for(i=0; i<NBR_BOATS; i++) tries[i] = 0;

	grid()->clear();
	
	i=0;
	do
	{
		row = random(SIZE_GRID);
		col = random(SIZE_GRID);
		horiz = (random(2)==0);

		if(grid()->canPlaceNewBoat(row, col, horiz, boatSizes[ boatTypes[i] ]))
		{
			grid()->placeBoat(row, col, horiz, new Boat(i, boatTypes[i]) );
			i++;
		}
		else
		{
			tries[i]++;
			if(i!=0 && tries[i]==AUTO_MAX_TRIES)
			{
				tries[i] = 0;
				i--;
				grid()->removeBoat(i);
			}
		}

	}
	while( i<NBR_BOATS );
}

/////////////////////////////////////////////////////////////////////////////


