#ifndef PLAYER_H
#define PLAYER_H

#include "main.h"
#include "GameMaster.h"
#include "GridData.h"

#define AUTO_MAX_TRIES	4

class Player
{
public:
	Player(int num, GameMaster* master);
	virtual ~Player();

	// Called by the game master
	virtual void yourTurn()=0;
	virtual void placeYourBoats()=0;
	virtual int priority()=0;
	virtual void opponentIsReady() {}
	virtual bool initOk()=0;

	CaseType getKnownCaseType(int row, int col)
		{ return m_grid.getKnownCaseType(row,col); }
	CaseType getRealCaseType(int row, int col)
		{ return m_grid.getRealCaseType(row,col); }

	int number() { return m_num; }
	GameMaster* master() { return m_pMaster; }

	virtual const ShotResult & opponentShot(int row, int col);

	virtual void shoot(int row, int col);
	virtual void myShotResult(const ShotResult &res) {}
	virtual void opponentShotResult(const ShotResult &res) {}

	GridData* grid() { return &m_grid; }

	void placeBoatsAuto();

private:
	int m_num;
	GameMaster* m_pMaster;
	GridData m_grid;
};

#endif

