#pragma once

#include "main.h"
#include "../MainFrame/MyWindow.h" 
class BattleShipDoc;
class Player;
class PlayerWdw;

	// Player Document interface
class PlayerDoc
{
public:
	//PlayerDoc()  {}

	virtual void setWindow(PlayerWdw* wdw)=0;

	virtual void shoot(int row, int col)=0;
	virtual CaseType getCaseType(int player, int row, int col)=0;
	virtual void getChangedCase(int &row, int &col)=0;
	virtual bool myTurn()=0;

	virtual int boatDamage(int player, int boatId)=0;

	virtual bool placingBoats()=0;
	virtual bool canPlaceBoat(int row, int col, bool horiz, int size)=0;
	virtual void placeBoat(int row, int col, bool horiz, int size)=0;
};

/////////////////////////////////////////////////////////////////////////////

class PlayerWdw : public MyWindow
{
public:
	PlayerWdw(PlayerDoc* doc);

	void onPenDown(const PegPoint &p);
	void onPenUp(const PegPoint &p); 
	void onPenMove(const PegPoint &p);
	bool onClearKeyPressed() { return false; }
	void onDraw();
	
	PegPoint getPxlForCase(int player, int row, int col);
	void drawExplosion(int num, PegPoint where);

	void newOrder(UpdateOrderType order);

private:
	void sayStatusBar(PEGCHAR* s);
	void sayStatusBar(BattleShipMessage msg) { sayStatusBar(GetLang(msg)); }
	PlayerDoc* playerDoc() { return m_doc; }
	int findCase(const PegPoint &p, int &row, int &col);
	void tryBoat(int row, int col);
	void drawGrid(int player, int x, int y);
	void drawBoatStates(int player, int x, int y);
	void drawPlacingBoat();
	void drawFrame(int player, int x, int y);

	PegPoint m_choosedPoint;

	bool m_boatBasePlaced;
	int m_boatBaseRow, m_boatBaseCol;
	bool m_boatValid;
	int m_boatLeft, m_boatTop, m_boatSize;
	bool m_boatHoriz;

	PlayerDoc* m_doc;
	static PegRect m_rect;
};
