#pragma once
#include <ClassPad.h>

#define SIZE_GRID		12
#define SIZE_CASE		6

#define ME_GRID_POS_X	5
#define ME_GRID_POS_Y	16
#define ME_BOATS_POS_X	99
#define ME_BOATS_POS_Y	16

#define OPP_GRID_POS_X	69
#define OPP_GRID_POS_Y	122
#define OPP_BOATS_POS_X	5
#define OPP_BOATS_POS_Y	122

#define FRAME_WIDTH		155
#define FRAME_HEIGHT	91

#define BOATS_HSPACE	9

#define BOAT_BS			0
#define BOAT_FR			1
#define BOAT_CR			2
#define BOAT_MS			3

#define NBR_BOAT_MS		3
#define NBR_BOAT_CR		3
#define NBR_BOAT_FR		2
#define NBR_BOAT_BS		1
#define NBR_BOATS		(NBR_BOAT_MS+NBR_BOAT_CR+NBR_BOAT_FR+NBR_BOAT_BS)

#ifdef WIN32
#	define EXPL_WAIT_TIME	30
#else
#	define EXPL_WAIT_TIME	50
#endif

#define ONE_PLAYER		1
#define TWO_PLAYERS		2

/////////////////////////////////////////////////////////////////////////////

extern byte boatTypes[NBR_BOATS];
extern byte boatSizes[];

extern PegBitmap bmpTitle;
extern PegBitmap bmpGrid;
extern PegBitmap bmpBoatFrame;
extern PegBitmap* caseBitmaps[];
extern PegBitmap* boatBitmaps[]; 

/////////////////////////////////////////////////////////////////////////////

enum UpdateOrderType 
{ 
	GlobalReset, 
	PlayerWon, 
	PlayerLost, 
	ChooseOpponentCase, 
	MeMissed,
	MeHit,
	MeDestroyed,
	OpponentMissed,
	OpponentHit,
	OpponentDestroyed,
	ReDraw
};

/////////////////////////////////////////////////////////////////////////////

#define MSG_BASE 2001

enum BattleMessage
{
	PLAYER0_TURN = MSG_BASE,
	PLAYER1_TURN,
	PLAYER0_WON,
	PLAYER1_WON,
	WAITING_FOR_PLAYING,
	BOATS_PLACED,
	IDB_NEWGAME,
	IDB_OPTIONS
};

/////////////////////////////////////////////////////////////////////////////

enum CaseType 
{ 
	UnKnown=0, 
	Water, 
	Intact, 
	Hit,
	Destroyed,
	Valid,
	UnValid
};

/////////////////////////////////////////////////////////////////////////////

class Boat;
struct ShotResult
{
	ShotResult(byte r=0, byte c=0, Boat* b=NULL)
		: row(r), col(c), boat(b), win(false) {}
	byte row, col;
	Boat* boat;
	bool win;
};

/////////////////////////////////////////////////////////////////////////////

#include "LangDataBase.h"

short random(short sup);

