/////////////////////////////////////////////////////////////////////////////
//			Custom Window System - MyMainFrame
//	
//				Julien Patte (orwell01@hotmail.com)
//	
//					version 0.9 (incomplete) - 29 jul 2005
//
// Note: You may freely use these files, but it's at your own risks ;)
/////////////////////////////////////////////////////////////////////////////

#ifndef MYMAINFRAME_H
#define MYMAINFRAME_H

#include <ClassPad.h>
#include "../MainFrame/MyWindow.h"

class DummyFrame : public CPMainFrame
{
public:
	DummyFrame() : CPMainFrame(m_rect) {}

	SIGNED Message(const PegMessage &msg);

private:
	static PegRect m_rect;
};

/////////////////////////////////////////////////////////////////////////////

class MyMainFrame : public PegWindow
{
public:
	MyMainFrame(PegRect rect = m_bigRect, WORD style = FF_NONE);
	~MyMainFrame();

	static MyMainFrame* mf();

	void setTitle(PegTitle* title);
	void setMenuBar(PegMenuBar* menu);
	void setToolBar(PegToolBar* tool);

	void addWindow(MyWindow* win);
	void removeWindow(MyWindow* win, bool bDraw = true);
	bool containsWindow(MyWindow* win);
	MyWindow* getActiveWindow();
	void setActiveWindow(MyWindow* win);
	PegWindow* getClientArea() { return m_client; }

	void placeInClient(MyWindow* win, int x, int y, bool redrawClient=true);

	void destroyTitle();
	void destroyMenuBar();
	void destroyToolBar();

	PegTitle* getTitle();
	PegMenuBar* getMenuBar();
	PegToolBar* getToolBar();
	PegStatusBar* getStatusBar();

	void statusBarText(PEGCHAR* string);

	PegRect defaultTitleRect();
	PegRect defaultMenuBarRect();
	PegRect defaultToolBarRect();
	PegRect clientRect();

	void toggleKeypad();
	void showKeypad(bool on);
	bool keypadOn();

	void allowResizeKey(bool on) { m_allowResizeKey = on; }

	void programQuit();

	void setFullScreenApp(bool on = true);

	static PegRect getFullRect() { return m_bigRect; }
	static PegRect getSmallRect() { return m_smallRect; }

	void Draw();
	SIGNED Message(const PegMessage &msg);

private:
	void prepareSignal(MyWindow* win, WORD signal);
	PegThing* getKeypad() { return (PegThing*) m_dummy.Keypad(); }
	void resizeClient();

	static MyMainFrame* m_instance;
	DummyFrame m_dummy;

	PegWindow* m_client;
	MyWindow* m_activeWin;
	CPList m_otherWin;

	PegTitle* m_titleBar;
	PegMenuBar* m_menuBar;
	PegToolBar* m_toolBar;
	PegStatusBar* m_statusBar;

	bool m_keyPadOn;
	bool m_fullScreen;
	bool m_allowResizeKey;

	static PegRect m_bigRect;
	static PegRect m_smallRect;
};

#endif

