/////////////////////////////////////////////////////////////////////////////
//			Custom Window System - MyWindow
//	
//				Julien Patte (orwell01@hotmail.com)
//	
//					version 0.9 (incomplete) - 29 jul 2005
//
// Note: You may freely use these files, but it's at your own risks ;)
/////////////////////////////////////////////////////////////////////////////

#include "../MainFrame/MyWindow.h"
#include "../MainFrame/MyMainFrame.h"

MyWindow::MyWindow(PegRect size, WORD style)
	: PegWindow(size, style)
	, m_focus(false)
	, m_posCorrected(false)
{
}

/////////////////////////////////////////////////////////////////////////////

void MyWindow::onDraw()
{
	DrawChildren();
}

/////////////////////////////////////////////////////////////////////////////

SIGNED MyWindow::Message(const PegMessage &Mesg)
{
	PegPoint p;
	switch(Mesg.wType)
	{
	case PM_LBUTTONDOWN: 
		p = Mesg.Point;
		Screen2Window(p);
		onPenDown(p);
		break;
			
	case PM_LBUTTONUP:
		p = Mesg.Point;
		Screen2Window(p);
		onPenUp(p);
		break;

	case PM_POINTER_MOVE:
		p = Mesg.Point;
		Screen2Window(p);
		onPenMove(p);
		break;

	case PM_KEY:
		onKeyPressed(Mesg.iData, Mesg.lData);
		break;

	case PM_TIMER:
		onTimerTick(Mesg.iData);
		break;

	case PM_GAINING_FOCUS:
		m_focus = true;
		onFocusReceived();
		break;

	case PM_LOSING_FOCUS:
		m_focus = false;
		onFocusLost();
		break;
	}
	return PegWindow::Message(Mesg);
}

/////////////////////////////////////////////////////////////////////////////

void MyWindow::Draw()
{
	BeginDraw();
	DrawFrame();
	onDraw();
	EndDraw();
}

/////////////////////////////////////////////////////////////////////////////

void MyWindow::placeInClient(int x, int y)
{
	mainFrame()->placeInClient(this, x, y);
}

/////////////////////////////////////////////////////////////////////////////

void MyWindow::AddR(PegThing *pWho, BOOL bDraw)
{
	PegRect r = pWho->mReal;
	r.Shift(mClient.wLeft, mClient.wTop);
	pWho->Resize(r);
	Add(pWho, bDraw);
}

/////////////////////////////////////////////////////////////////////////////

void MyWindow::declareSignal(WORD signalId)
{
	ent ptr;
    CPListIterator it(&m_signals);
    bool found = false;
	for(ptr = it.Head(); found == false && ptr!=NULL; ptr = it.Next()) found = (*((WORD*)ptr) == signalId);

	if(!found) m_signals.Append( new WORD(signalId) );
}

/////////////////////////////////////////////////////////////////////////////

void MyWindow::removeSignal(WORD signalId)
{
	ent ptr;
	CPListIterator it(&m_signals);
	for(ptr = it.Head(); ptr!=NULL; ptr = it.Next())
	{
		if(*((WORD*)ptr) == signalId)
		{
			m_signals.Remove(ptr);
			delete ptr;
			break;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////

MyMainFrame* MyWindow::mainFrame()
{ 
	return MyMainFrame::mf(); 
}

/////////////////////////////////////////////////////////////////////////////

void MyWindow::askFocus()
{ 
	mainFrame()->setActiveWindow(this); 
}

/////////////////////////////////////////////////////////////////////////////
