/////////////////////////////////////////////////////////////////////////////
//			Custom Window System - MyWindow
//	
//				Julien Patte (orwell01@hotmail.com)
//	
//					version 0.9 (incomplete) - 29 jul 2005
//
// Note: You may freely use these files, but it's at your own risks ;)
/////////////////////////////////////////////////////////////////////////////

#ifndef MYWINDOW_H
#define MYWINDOW_H

#include <ClassPad.h>

class MyMainFrame;
class MyWindow : public PegWindow
{
public:
	MyWindow(WORD style = FF_NONE);
	MyWindow(PegRect posInClient, WORD style = FF_NONE);
	~MyWindow() {}

	// useful services
	void placeInClient(int x, int y);
	bool hasFocus()		{ return m_focus; }
	void askFocus();
	MyMainFrame* mainFrame();
	void AddR(PegThing *pWho, BOOL bDraw=true);
	void declareSignal(WORD signalId);
    void removeSignal(WORD signalId);

	// event handlers
	virtual void onPenDown(const PegPoint &p) {}
	virtual void onPenMove(const PegPoint &p) {}
	virtual void onPenUp(const PegPoint &p) {}

	virtual void onFocusReceived() {}
	virtual void onFocusLost() {}

	virtual void onDraw();
	
	virtual void onKeyPressed(WORD iData, WORD lData) {}
	virtual bool onClearKeyPressed() { return true; }

	virtual void onSignal(WORD signalId) {}

	virtual void onTimerTick(WORD timerId) {}

	// others (should be less useful now :) )
	virtual SIGNED Message(const PegMessage &Mesg);
	virtual void Draw();

	// used by MyMainFrame
	CPList* handledSignalsList() { return &m_signals; }
	bool posCorrected() { return m_posCorrected; }
	void setPosCorrected(bool yes) { m_posCorrected = yes; }

private:
	bool m_focus;
	CPList m_signals;
	bool m_posCorrected;
};

#endif

